<?php

$itemIndex = 0 ;

class Product{
	var $id ;
	var $name ;
	var $oldPrice ;
	var $newPrice ;
	var $picture ;
	var $brief ;

	function Product($id,$name,$oldPrice,$newPrice,$picture,$brief){
		$this->id = $id ;
		$this->name = $name ;
		$this->oldPrice = $oldPrice ;
		$this->newPrice = $newPrice ;
		$this->picture = $picture ;
		$this->brief = $brief ;
		
		$max = 60 ;
		$len = strlen($this->brief) ;
		if($len > $max){
			$this->brief = substr($this->brief , 0 ,$max) . "..." ;
		}
	}

	function getHTML(){
		$html = "";
		$html .= "<TABLE cellspacing=0 cellpadding=0 style='width:100%;border-bottom:#F4F4F4 1px solid;'>";
		$html .= "<TR>";
		$html .= "	<TD style='padding:3px;>";
		$html .= "	<div style='width:50px;'>";
		$html .= "		<img src='". $this->picture ."' width=77 border=0></img>" ;
		$html .= "	</div>";
		$html .= "	</TD>";
		$html .= "	<TD style='padding:4px;width:90%;'>";
		$html .= "		<div style='padding-bottom:4px;font-weight:bold;'>". $this->name ."</div>" ;
		$html .= "		<div style='font-size:8pt;font-style:italic;color:red;text-decorate:underline;'>г:". $this->oldPrice ."</div>" ;
		$html .= "		<div style='font-size:8pt;font-style:italic;color:blue;'>:". $this->newPrice ."</div>" ;
		$html .= "		<div>". $this->brief ."</div>" ;
		$html .= "	</TD>";
		$html .= "	<TD style='padding:3px;>";
		$html .= "	<div style='width:8px;'>";
		$html .= "	</div>";
		$html .= "	</TD>";
		$html .= "</TR>";
		$html .= "</TABLE>";
		return $html ;
	}

	function setId($id){
		$this->id = $id ;
	}	
	function setName($name){
		$this->name = $name ;
	}
	function setOldPrice($oldPrice){
		$this->oldPrice = $oldPrice ;
	}
	function setNewPrice($newPrice){
		$this->newPrice = $newPrice ;
	}
	function setPicture($picture){
		$this->picture = $picture ;
	}
	function setBrief($brief){
		$this->brief = $brief ;
	}
}

class S2_Table{
	var $title ;
	var $width = "300px";
	var $bgColor = "#1EA621";
	var $txtColor = "#FFFFFF";
	var $moreLink = "";
	var $borderColor = "#1EA621";
	var $contentBGColor = "#EFFCEF";
	var $detailPage = "#";
	var $items = array() ;

	function S2_Table($title){
		$this->title = $title ;
		$this->bgColor = getRGBColor(30);
		$this->txtColor = getRGBColor(100);
		$this->borderColor = getGrayColor(80);
		$this->contentBGColor = getRGBColor(98);
	}

	function setMoreLink($url){
		$this->moreLink = $url ;
	}

	function setDetailPage($page){
		$this->detailPage = $page ;
	}

	function addProduct($product){
		array_push($this->items,$product);
	}

	function printHTML(){
		print($this->getHead());
		$size = count($this->items) ;
		for($i=0;$i<$size;$i++){
			$item = $this->items[$i];
			print($item->getHTML());
		}
		print($this->getFoot());
	}

	function getHead(){
		$html  = "<div style='padding:0px;border-right:#D6D6D6 2px solid;border-bottom:D6D6D6 2px solid;width:". $this->width .";'>";
		$html .= "<TABLE cellspacing=0 cellpadding=0 style='width:". $this->width .";padding:0px;border:gray 1px solid;'>";
		$html .= "<TR>";
		$html .= "	<TD style='padding-top:3px;background-color:#A6A6A6;color:". $this->txtColor .";text-align:center;'>";
		$html .= "	<div style='width:".$this->width.";height:24px;font-size:10pt;font-weight:normal;padding-top:4px;'>";
		$html .=		$this->title ;
		$html .= "	</div>";
		$html .= "	</TD>";
		$html .= "</TR>";
		$html .= "<TR>";
		$html .= "	<TD colspan=2 style='padding:6px;'> ";
		
		return $html ;
	}

	function getFoot(){
		$html = "";
		$html .= "	</TD>";
		$html .= "</TR>";
		$html .= "</TABLE>";
		$html .= "</div>";
		return $html ;
	}
}

?>