<?php

class TreeNode{
	var $id ;
	var $name ;
	var $parentId ;
	var $parentNode ;
	var $icon ;
	var $showChapterNo = false ;
	var $clickMethod = "";
	var $children = array() ;
	var $lines = array();
	var $rank = 0 ;
	var $sequence = 0;
	var $subSequence = 0;
	var $chapterNo = "" ;
	var $shadowIndex ;
	var $display = 'Y' ;
	var $open = 'Y' ;
	var $openFolderIcon = "../tree/folderOpen.gif";
	var $closeFolderIcon = "../tree/folderClose.gif";

	public function TreeNode($id,$name,$parentId,$icon){
		$this->id = $id ;
		$this->name = $name ;
		$this->parentId = $parentId ;
		$this->icon = $icon ;
		$this->open = "Y";
		$this->display = "Y" ;
	}

	public function getViewHTML($currentFocusNodeId){
		if(!$this->isDisplay()){
			return "";
		}
		
		$crlf = "\r\n";
		$tab = "\t";
		
		$html = "";
		$html .= "<tr id='".$this->id."_ROW_'>$crlf";
		$html .= "<td style='height:18px;padding:0px;'>$crlf";
		
		$html .= "$tab<table cellspacing=0 cellpadding=0 style='border:red 0px solid;'>$crlf";
		$html .= "$tab<tr>$crlf";

		$lines = $this->lines ;
		for($i=0;$i<count($lines);$i++){
			if($lines[$i] == "1"){
				$html .= "$tab$tab<td><div class='YHMenu_nodeLine'></div></td>$crlf";
			}else{
				$html .= "$tab$tab<td><div class='YHMenu_nodeEmpty'></div></td>$crlf";
			}
		}
		$html .= "$tab$tab<td class='".$this->getNodeCss()."' onclick=\"refreshTreeView('".$this->id."')\"><div style='width:18px;'></div></td>$crlf";
		$html .= "$tab$tab<td><div class='YHMenu_nodeIcon' style='background-image:url(".$this->getIcon().");background-repeat:no-repeat;background-position:0% 50%;' class='menuIcon'></div></td>$crlf";
		$html .= "$tab$tab<td id='_TEXT_NODE_".$this->id."' nodeId='".$this->id."'";

		if($this->clickMethod != null && $this->clickMethod != ""){
			$html .= " onclick=\"".$this->clickMethod."('".$this->id."')\"";
		}

		$html .= " class='".$this->getTextNodeCss($currentFocusNodeId)."' onmouseover='overTextNode(this)' onmouseout='outTextNode(this)' onclick='clickTextNode(this)'>$crlf";
		$html .= "$tab$tab$tab<div class='divTextNode'>";

		// $html .= $this->chapterNo." ";

		$html .= $this->getName();
		$html .= "</div>$crlf";
		$html .= "$tab$tab</td>$crlf";

		$html .= "$tab</tr>$crlf";
		$html .= "$tab</table>$crlf";

		$html .= "</td>$crlf";
		$html .= "</tr>$crlf";
		
		return $html;
	}

	public function getNodeCss(){
		return "YHMenu_node" . ($this->isOpen()?"1":"0") . ($this->hasYoungerBrother()?"1":"0") . ($this->hasChild()?"1":"0") ;
	}

	public function getTextNodeCss($id){
		if($this->id == $id){
			return "spanNode3" ;
		}
		return "spanNode1" ;
	}

	public function refreshDisplay(){
		if($this->parentNode == null || $this->parentId == ""){
			$this->display = "Y" ;
		}else{
			if(!$this->parentNode->isOpen()){
				$this->display = "N" ;
			}else if(!$this->parentNode->isDisplay()){
				$this->display = "N" ;
			}else{
				$this->display = "Y" ;
			}
		}
	}

	public function refreshChapterNo(){
		if($this->parentNode == null){
			$this->chapterNo = "" ;
		}else{
			$temp = $this->parentNode->chapterNo ;
			if($temp == ''){
				$this->chapterNo =  $this->subSequence + 1 ;
			}else{
				$this->chapterNo =  $temp . "." . ($this->subSequence + 1) ;
			}
		}
	}

	public function refreshRank(){
		if($this->parentNode == null || $this->parentId == ""){
			$this->rank = 0 ;
		}else{
			$this->rank = ($this->parentNode->rank + 1) ;
		}
	}

	public function findAncestorById($ancestorId){
		if($this->parentNode == null || $this->parentId == ""){
			return null ;
		}
		$node = $this->parentNode ;
		if($node->id == $ancestorId){
			return $node ;
		}else{
			return $node->findAncestorById($ancestorId) ;
		}
	}

	public function hasChild(){
		return count($this->children) > 0 ;
	}

	public function hasElderBrother(){
		return $this->subSequence > 0 ;
	}

	public function hasYoungerBrother(){
		if($this->parentNode == null || $this->parentId == ""){
			return false ;
		}
		$c = count($this->parentNode->children) - 1;
		return $c > $this->subSequence ;
	}

	public function addChild($node){
		$node->subSequence = count($this->children) ;
		$node->parentId = $this->id ;
		$node->parentNode = $this ;
		$node->rank = $this->rank + 1 ;
		
		array_push($this->children , $node);
	}

	public function removeChild($id){
		$matrix = array();
		$size = $this->childrenSize();
		$begin = false ;
		$child ;
		for($i=0;$i<$size;$i++){
			$node = $this->children[$i];
			if($node->id == $id){
				$child = $node ;
				$begin = true ;
				continue ;
			}
			if($begin){
				$node->subSequence-- ;
			}
			array_push($matrix,$node);
		}
		$this->children = $matrix ;
		unset($child) ;
	}
	
	public function childrenSize(){
		return count($this->children) ;
	}

	public function nextSibling(){
		if($this->hasYoungerBrother()){
			return $this->parentNode->children[$this->subSequence + 1];
		}
		return null ;
	}

	public function getDebugName(){
		return "id=".$this->id.",name=".$this->name.",parentId=".$this->parentId.",rank=".$this->rank.",sequence=".$this->sequence.",subSequence=".$this->subSequence.",display=".$this->display.",open=".$this->open;
	}

	public function getName(){
		if($this->showChapterNo){
			return $this->chapterNo . ". " . $this->name ;
		}
		return $this->name;
	}

	public function changeOpenStatus(){
		if($this->open == "Y"){
			$this->open = "N";
		}else{
			$this->open = "Y";
		}
	}

	public function getIcon(){
		if($this->icon != ""){
			return $this->icon ;
		}
		if($this->isOpen()){
			return $this->openFolderIcon;
		}
		return $this->closeFolderIcon;
	}

	public function isOpen(){
		return $this->open == "Y";
	}

	public function isDisplay(){
		return $this->display == "Y";
	}

}

class Tree extends TreeNode{
	var $root ;
	var $displyDegree = 2 ;
	var $inited = false ;
	var $currentFocusNodeId = "";
	var $nodeMap = array();
	var $tempMap = array();
	var $nodeList = array();
	var $pointer = null ;

	public function Tree($id,$name,$icon,$displyDegree){
		$this->displyDegree = $displyDegree ;
		$this->root = new TreeNode($id,$name,null,$icon);
		$this->nodeMap[$id] = $this->root ;
	}

	public function getTreeHTML(){
		$crlf = "\r\n";
		$html = "";
		$html .= "<table cellspacing=0 cellpadding=0 style='border:0px;'>$crlf";
		for($i=0;$i<$this->size();$i++){
			$node = $this->nodeList[$i];
			$html .= $node->getViewHTML($this->currentFocusNodeId);
		}
		$html .= "</table>$crlf";
		return $html ;
	}

	public function size(){
		return count($this->nodeList) ;
	}

	public function add($node){
		if (array_key_exists($node->id, $this->nodeMap)) {
			return ;
		}
		$node->showChapterNo = $this->showChapterNo ;

		$parent = $this->findNodeById($node->parentId);
		if($node->parentId == null || $node->parentId == ""){
			$parent = $this->root ;
		}
		if($parent != null){
			$parent->addChild($node);
			$this->nodeMap[$node->id] = $node ;
		}else{
			$this->tempMap[$node->id] = $node ;
		}
	}

	public function addAndRefresh($node){
		$this->add($node) ;
		$this->init();
	}

	public function init(){
		$this->pointer = null ;
		
		$this->sortNodes();
		$this->initSequence();
		$this->initShadowIndex();
		$this->initLines();

		$this->inited = true ;
	}

	public function sortNodes(){
		while(count($this->tempMap) > 0){
			$matrix = array() ;
			while(list($id,$node)=each($this->tempMap)){
				$parent = $this->findNodeById($node->parentId);
				if($parent != null){
					$this->add($node);
					continue ;
				}else if(!array_key_exists($node->parentId,$this->tempMap)){
					$node->parentId = $this->root->id ;
					$this->add($node);
					continue ;
				}else{
					$matrix[$id] = $node ;
				}
			}
			$this->tempMap = $matrix ;
		}
	}

	public function initSequence(){
		$this->nodeList = array();
		$this->nodeMap = array();

		$index = 0 ;
		$node = $this->goNext();
		while($node != null){

			$node->sequence = $index++ ;
			$node->refreshChapterNo();
			$node->refreshRank();
			array_push($this->nodeList , $node);
			$this->nodeMap[$node->id] = $node ;

			if(!$this->inited){
				$node->open = ($node->rank < $this->displyDegree) ? "Y" : "N";
			}
			$node->refreshChapterNo() ;
			$node->refreshDisplay() ;
			$node->lines = array();
			
			$node = $this->goNext();

		}
	}

	public function goNext(){
		if($this->pointer == null){
			$this->pointer = $this->root ;
		}else{
			if($this->pointer->childrenSize() > 0){
				$this->pointer = $this->pointer->children[0];
			}else{
				if($this->pointer->parentNode == null){
					return null ;
				}else if($this->pointer->nextSibling() != null){
					$this->pointer = $this->pointer->nextSibling() ;
				}else{
					$parentNode = $this->pointer->parentNode;
					$brother = $parentNode->nextSibling() ;

					while($parentNode != null && $brother == null){
						$brother = $parentNode->nextSibling();
						$parentNode = $parentNode->parentNode;
					}
					$this->pointer = $brother ;
				}
			}
		}
		return $this->pointer ;
	}

	public function initShadowIndex(){
		$size = $this->size() ;
		for($i=0;$i<$size;$i++){
			$node = $this->nodeList[$i];
			$node->shadowIndex = $node->sequence ;
			for($j=($node->sequence + 1);$j<$size;$j++){
				$temp = $this->nodeList[$j];
				if($node->rank < $temp->rank){
					$node->shadowIndex = $temp->sequence ;
				}else{
					break ;
				}
			}
		}	
	}

	public function initLines(){
		$size = $this->size() ;
		for($i=0;$i<$size;$i++){
			$node = $this->nodeList[$i];
			$line = $node->hasYoungerBrother();
			for($j=$node->sequence +1 ; $j <= $node->shadowIndex;$j++){
				$temp = $this->nodeList[$j];
				array_push($temp->lines,$line);
			}
		}
	}

	public function expandAll(){
		$size = $this->size() ;
		for($i=0;$i<$size;$i++){
			$node = $this->nodeList[$i];
			$node->open = "Y";
			$node->display = "Y";
		}
	}

	public function closeAll(){
		$size = $this->size() ;
		for($i=1;$i<$size;$i++){
			$node = $this->nodeList[$i];
			$node->open = "N";
			$node->display = "N";
		}
	}

	public function changeNodeOpenStatus($id){
		$node = $this->findNodeById($id) ;
		
		if($node != null){
			$node->changeOpenStatus();
			$size = $this->size() ;

			for($j=($node->sequence+1); $j<$size; $j++){
				$temp = $this->nodeList[$j];
				if($temp->rank <= $node->rank){
					break ;
				}				
				$temp->refreshDisplay();
			}

		}else{
			// echo "no node ".$id ;
		}
	}

	public function changeNodeName($id,$name){
		$node = $this->findNodeById($id) ;
		if($node != null){
			$node->name = $name ;
		}
	}

	public function removeNode($id){
		$node = $this->findNodeById($id) ;
		if($node == null){
			return ;
		}
		$parent = $node->parentNode ;
		if($parent != null){
			$parent->removeChild($node->id);
		}

		$node->parentId = "";
		$node->parentNode = null ;
		$this->init();
	}

	public function resetNodeParent($id,$parentId){
		$node = $this->findNodeById($parentId) ;
		$temp = $node->findAncestorById($id);
		if($temp != null){
			// echo "can move ancestor under offspring";
			return  false ;
		}

		$node = $this->findNodeById($id) ;
		if($node == null){
			return false;
		}
		$this->removeNode($id);

		$node->parentId = $parentId;
		$parent = $this->findNodeById($parentId) ;
		$node->parentNode = $parent ;

		$this->add($node);

		$this->init();
		return true ;
	}

	public function findMeAndMyAncestors($id){
		$matrix = array() ;
		$node = $this->findNodeById($id) ;
		while($node != null){
			array_push($matrix,$node->id);
			$node = $node->parentNode ;
		}
		return $matrix ;
	}

	public function findMeAndMyOffsprings($id){
		$matrix = array() ;

		$size = $this->size() ;
		$node = $this->findNodeById($id) ;
		if($node != null){
			array_push($matrix,$node->id);
			for($j=($node->sequence+1); $j<$size; $j++){
				$temp = $this->nodeList[$j];
				if($temp->rank <= $node->rank){
					break ;
				}
				array_push($matrix,$temp->id);
			}
		}
		return $matrix ;
	}

	public function findNodeById($id){
		if(array_key_exists($id,$this->nodeMap)){
			return $this->nodeMap[$id];
		}
		return null ;
	}
}
?>