<?php


function getFullNodeTree(){
	$sqlstr = "select * from view_docs order by rank,sequence";
	return getTreeBySQL($sqlstr);
}

function getFolderTree(){
	$sqlstr = "select folder_id as id,folder_name as name,parent_id from folder order by rank,sequence";
	return getTreeBySQL($sqlstr);
}

function saveFolderTree($tree){
	$list = $tree->nodeList ;
	for($i=0;$i<count($list);$i++){
		$node = $list[$i];
		$sqlstr = "update folder set parent_id='".$node->parentId."',sequence='".$node->sequence."',rank='".$node->rank."' where folder_id='".$node->id."'";
		// echo $sqlstr . "<br>";
		doQuery($sqlstr);
	}
}

function getTreeBySQL($sqlstr){
	$result = getResult($sqlstr) ;
	$rootId = "A000000000000000";
	$rootName = "HOME";
	$tree = new Tree($rootId,$rootName,"",2);
	if(count($result) > 0){
		for($i=0;$i<count($result) ; $i++){
			$nodeId = $result[$i]["id"];
			$nodeName = $result[$i]["name"];
			$parentId = $result[$i]["parent_id"];
			$node = new TreeNode($nodeId,$nodeName,$parentId,'');
			$tree->add($node) ;
		}
	}
	$tree->init();
	return $tree ;
}

$folder_id = requestToSession("folder_id");
if($folder_id == ""){
	$folder_id = "A000000000000000";
}

$system_flag = get("system_flag");
$entityId = get("entityId");
$renameEntityId = get("renameEntityId");
$folderTreeKey = "_FLODER__TREE_" ;

if($system_flag == "createFolder"){
	if(session_is_registered($folderTreeKey)){
		$temp = $_SESSION[$folderTreeKey] ;
		$tree = unserialize($temp);

		$nodeId = getUniqueId(16);
		$renameEntityId = $nodeId ;
		$nodeName = get("folderName");

		$node = new TreeNode($nodeId,$nodeName,$folder_id,'');
		$node->clickMethod = "changeFolder";
		$node->open = "N";
		$tree->addAndRefresh($node);

		$sqlstr = "delete from folder";
		doQuery($sqlstr) ;

		$sqlstr = "insert into folder (folder_id,folder_name,parent_id,user_id,create_user,create_time,sequence,rank) values ";
		$size = $tree->size();
		for($i=1;$i<$size;$i++){
			$node = $tree->nodeList[$i];
			if($i > 1){
				$sqlstr .= ",";
			}
			$sqlstr .= "('".$node->id."','".sqlSafeReplace($node->name)."','".$node->parentId."','".$uid."','".$uid."',current_timestamp,$i,".$node->rank.")";
		}
		doQuery($sqlstr) ;
	
		// echo $sqlstr ;
		doQuery($sqlstr) ;

		// session_unregister($folderTreeKey);
		$_SESSION[$folderTreeKey] = serialize($tree) ;
	}
}else if($system_flag == "reloadTree"){
	session_unregister($folderTreeKey);
}else if($system_flag == "expandTree"){
	if(session_is_registered($folderTreeKey)){
		$temp = $_SESSION[$folderTreeKey] ;
		$tree = unserialize($temp);
		$tree->expandAll();
		$_SESSION[$folderTreeKey] = serialize($tree) ;
	}
}else if($system_flag == "closeTree"){
	if(session_is_registered($folderTreeKey)){
		$temp = $_SESSION[$folderTreeKey] ;
		$tree = unserialize($temp);
		$tree->closeAll();
		$_SESSION[$folderTreeKey] = serialize($tree) ;
	}
}else if($system_flag == "changeFileName"){
	if($entityId != "" && get("entityName") != ""){
		if(get("entityFlag") == "dir"){
			$sqlstr = "update folder set folder_name='".getSQLSafeReplaced("entityName")."',last_update_time=current_timestamp where folder_id='".$entityId."'";
			doQuery($sqlstr);

			if(session_is_registered($folderTreeKey)){
				$temp = $_SESSION[$folderTreeKey] ;
				$tree = unserialize($temp);
				$tree->changeNodeName($entityId,get("entityName"));
				$_SESSION[$folderTreeKey] = serialize($tree) ;
			}

		}else{
			$matrix = explode(".",getSQLSafeReplaced("entityName"));
			$type = "";
			if(count($matrix) > 0){
				$type = $matrix[count($matrix) - 1];
			}
			$sqlstr = "update document set document_name='".getSQLSafeReplaced("entityName")."',document_type='".$type."',last_update_time=current_timestamp where document_id='".$entityId."'";
			doQuery($sqlstr);
		}
	}else{
		// echo $entityId. " / " . get("entityName");
	}
}else if($system_flag == "copyFile"){
	if($entityId != ""){
		$sqlstr = "select save_name from document where document_id='".$entityId."'";
		//echo $sqlstr ;

		$savename = getFirstVal($sqlstr);
		$matrix = explode(".",$savename);
		$type = "";
		if(count($matrix) > 0){
			$type = "." . $matrix[count($matrix) - 1];
		}
		
		$newname = time() . $type ;

		$matrix = explode("/",$savename);
		$matrix[count($matrix) - 1] = $newname ;
		$newSaveName = implode("/",$matrix);
		
		copy($savename,$newSaveName);

		$newid = getUniqueId(16);

		$sqlstr = "insert into document (document_id,document_name,keywords,copy_from_id,folder_id,status_id,document_type,file_name,save_name,file_size,upload_time,create_user,create_time,last_update_user,last_update_time) select '$newid' as document_id, concat('copy-',document_name) as document_name,keywords,document_id as copy_from_id,folder_id,status_id,document_type,file_name,'$newSaveName' save_name,file_size,upload_time,create_user,create_time,last_update_user,last_update_time from document where document_id='".$entityId."'";

		//echo $sqlstr ;

		doQuery($sqlstr);

		$renameEntityId = $newid ;
	}
}else if($system_flag == "deleteFile"){
	$entityFlag = get("entityFlag");
	$sqlstr = "update document set status_id=2 where document_id='$entityId'";
	if($entityFlag == "dir"){
		$sqlstr = "update folder set status_id=2 where folder_id='$entityId'";
	}
	doQuery($sqlstr);
	
	if(session_is_registered($folderTreeKey)){
		$temp = $_SESSION[$folderTreeKey] ;
		$tree = unserialize($temp);
		$tree->removeNode($entityId);
		$_SESSION[$folderTreeKey] = serialize($tree) ;
	}
}else if($system_flag == "resumeFile"){
	$entityFlag = get("entityFlag");
	$tree = getFullNodeTree();
	$matrix = $tree->findMeAndMyAncestors($entityId);
	$ids = "";
	for($i=0;$i<count($matrix);$i++){
		$ids .= ",'".$matrix[$i]."'";
	}
	
	$sqlstr = "update document set status_id=1 where document_id in ('".$entityId."'$ids)";
	// echo $sqlstr ;
	doQuery($sqlstr);

	$sqlstr = "update folder set status_id=1 where folder_id in ('".$entityId."'$ids)";
	doQuery($sqlstr);
	
	session_unregister($folderTreeKey);
}else if($system_flag == "realRemoveFile"){
	$entityFlag = get("entityFlag");
	$tree = getFullNodeTree();
	$matrix = $tree->findMeAndMyOffsprings($entityId);
	$ids = "";
	for($i=0;$i<count($matrix);$i++){
		$ids .= ",'".$matrix[$i]."'";
	}

	$sqlstr = "update document set status_id=3 where document_id in (''$ids)";
	doQuery($sqlstr);

	$sqlstr = "update folder set status_id=3 where folder_id in (''$ids)";
	doQuery($sqlstr);
	
	session_unregister($folderTreeKey);
}else if($system_flag == "changeNodeParent"){
	$parentId = get("parentId");
	$entityFlag = get("entityFlag");
	
	if($entityFlag == "file"){
		$sqlstr = "update document set folder_id='".$parentId."' where document_id in ('".$entityId."')";
		$result = doQuery($sqlstr) ;
		// echo $result;		
	}else{
		$tree = getFolderTree();
		if($tree->resetNodeParent($entityId,$parentId)){
			saveFolderTree($tree);
			session_unregister($folderTreeKey);
		}
	}
}

?>















