<?php

class InputText extends FormElement{
	function InputText($name,$type,$value,$attrs){
		$this->tagName = "input";
		$this->setAttribute("name",$name);
		$this->setAttribute("type",$type);
		$this->setAttribute("id",$name);
		$this->setAttribute("value",$value);
		if(strtolower($type) != "image"){
			$this->setAttribute("size",32);
		}
		parent::initAttributes($attrs);
	}
    
    public function getHTML(){
		$html  = parent::getHTML();

		$notnull = "not_null";
		if(strtolower($this->getAttribute($notnull)) == "y"){
			$html .= parent::$_CRLF;
			$html .= $this->getTabs();
			$html .= "<span style='color:red;padding:2px;'>*</span>";
		}

		return $html ;
    }
}

class Button extends FormElement{
	function Button($name,$value,$attrs){
		$this->tagName = "input";
		$this->setAttribute("type","button");
		$this->setAttribute("class","button");
		$this->setAttribute("name",$name);
		$this->setAttribute("id",$name);
		$this->setAttribute("value",$value);
		parent::initAttributes($attrs);
	}
}

class Submit extends FormElement{
	function Submit($name,$value,$attrs){
		$this->tagName = "input";
		$this->setAttribute("type","submit");
		$this->setAttribute("class","button");
		$this->setAttribute("name",$name);
		$this->setAttribute("id",$name);
		$this->setAttribute("value",$value);
		parent::initAttributes($attrs);
	}
}

class Radio extends FormElement{
	var $checked = false;
	function Radio($name,$value,$checked,$text,$attrs){
		$this->tagName = "input";
		$this->setAttribute("type","radio");
		$this->setAttribute("name",$name);
		$this->setAttribute("id",$name);
		$this->setAttribute("value",$value);
		$this->checked = $checked;
		if($text != null){
			$this->appendText($text) ;
		}
		parent::initAttributes($attrs);
	}

	public function getHTMLBegin(){
		$html  = HTMLTag::$_CRLF ;
		
		$html .= $this->getTabs();
		$html .= "<".$this->tagName;

		while(list($name,$value)=each($this->attributes)){
			if($value == ""){
				continue ;
			}

			$html .= " ".$name."=\"";
			$html .= $this->replaceValue($value) ;
			$html .= "\"";
		}

		if($this->checked){
			$html .= " checked";
		}
		$html .= "/>";	
		
		return $html ;
	}

	public function getHTMLEnd(){
		return "";
	}
}

class TextArea extends FormElement{
	var $value = "";
	function TextArea($name,$value,$attrs){
		$this->tagName = "textarea";
		$this->setAttribute("class","area");
		$this->setAttribute("name",$name);
		$this->setAttribute("id",$name);
		$this->value = $value;
		parent::initAttributes($attrs);
	}

	public function getHTMLBegin(){
		$html  = HTMLTag::$_CRLF ;
		
		$html .= $this->getTabs();
		$html .= "<".$this->tagName;

		while(list($name,$value)=each($this->attributes)){
			if($value == ""){
				continue ;
			}

			$html .= " ".$name."=\"";
			$html .= $this->replaceValue($value) ;
			$html .= "\"";
		}

		$html .= ">";
		
		return $html ;
	}

	public function getHTMLEnd(){
		return "</".$this->tagName.">";
	}

	public function getHTML(){
		return $this->getHTMLBegin() . $this->value . $this->getHTMLEnd() ;
	}
}

?>