<?php

class ListTable extends Table{
	var $rowIndex = -1 ;
	var $fixedRows = 0 ;
	var $cssColTitle = "col_title";
	var $cssRow = "row_0";
	var $widths ;
	var $aligns ;

	function ListTable($fixedRows){
		$this->tagName = "table" ;
		$this->setAttribute("class","table_list");
		$this->setAttribute("cellspacing",0);
		$this->setAttribute("cellpadding",0);
		$this->setAttribute("align","center");
		$this->fixedRows = $fixedRows + 1;
	}

	function getHTML(){
		$this->fixedRows();
		$this->initCellCss();
		return parent::getHTML();
	}

	function fixedRows(){
		if($this->fixedRows <= 0){
			return ;
		}
		$n = $this->fixedRows - $this->totalRows();
		if($n <= 0){
			return ;
		}
		$m = $this->row(0)->totalCols();
		// echo $n.",".$m ;
		for($i=0;$i<$n;$i++){
			$row = $this->newRow();
			for($j=0;$j<$m;$j++){
				$row->newCol()->add(new TextNode(""));
			}
		}
		// echo $this->totalRows();
	}
	function initCellCss(){
		$rows = $this->totalRows();
		if($rows > 0){
			$row = $this->row(0);
			$cols = $row->totalCols();

			for($t=0;$t<$cols;$t++){
				$col = $row->col($t);
				$col->setAttribute("class",$this->cssColTitle);
			}
		}

		$matrix = explode(",",$this->aligns) ;
		$len = count($matrix);

		$rows = $this->totalRows();
		// echo $rows ;
		if($rows > 1){
			for($i=1;$i<$rows;$i++){
				$row = $this->row($i);
	
				$row->setAttribute("class",$this->cssRow);
				if($row->getAttribute("onmouseover") == ""){
					$row->setAttribute("onmouseover","mouseOverRow(this)");
				}

				$cols = $row->totalCols();

				for($t=0;$t<$cols;$t++){
					$col = $row->col($t);
					if($len > $t){
						$temp = strtolower($matrix[$t]);

						if($temp != "" && $temp != "*"){
							$col->setAttribute("class","col_". $temp);
						}else{
							$col->setAttribute("class","col_l");
						}
					}else{
						$col->setAttribute("class",$this->cssColL);
					}
				}
			}
		}


		$matrix = explode(",",$this->widths) ;
		$len = count($matrix);

		$rows = $this->totalRows();
		if($rows > 0){
			$row = $this->row(0);
			$cols = $row->totalCols();

			for($t=0;$t<$cols;$t++){
				$col = $row->col($t);
				if($len > $t){
					$temp = strtolower($matrix[$t]);
					if($temp != "" && $temp != "*" && $temp != "?"){
						$col->setAttribute("style","width:".$temp."px");
					}
				}
			}
		}
	}

	function setAligns($aligns){
		$this->aligns = $aligns ;
	}

	function setWidths($widths){
		$this->widths = $widths ;
	}
}
?>