
var timeIndex	= 0;
var dbType		= "MSSQL";

function TimeStone(allowEmpty,timeName,defaultValue){
	var now_time = new Date(); 
	this.allowEmpty = allowEmpty ; 
	this.timeY = now_time.getYear();
	this.timeM = now_time.getMonth()+1;
	this.timeD = now_time.getDate();
	this.timeH = now_time.getHours();
	this.timeF = now_time.getMinutes();
	this.timeS = now_time.getSeconds();
	this.index = timeIndex++ ;
	this.value = this.timeY+"-"+lpad(this.timeM,'0',2)+"-"+lpad(this.timeD,'0',2)+" "+lpad(this.timeH,'0',2)+":"+lpad(this.timeF,'0',2);
	//alert(this.value);
	this.name = timeName ;

	if(defaultValue.length >= 16){
		this.timeY = defaultValue.substring(0,4);
		this.timeM = defaultValue.substring(5,7);
		this.timeD = defaultValue.substring(8,10);
		this.timeH = defaultValue.substring(11,13);
		this.timeF = defaultValue.substring(14,16);
		this.value = defaultValue ;
	}

	this.writeHTML = TimeStone_writeHTML ;
	this.getHTML = TimeStone_getHTML ;
	this.adjustDay = TimeStone_adjustDay ;
	this.getYearOptions = TimeStone_getYearOptions ;
	this.getMonthOptions = TimeStone_getMonthOptions ;
	this.getDayOptions = TimeStone_getDayOptions ;
	this.getHourOptions = TimeStone_getHourOptions ;
	this.getMinuteOptions = TimeStone_getMinuteOptions ;
	this.getSecondOptions = TimeStone_getSecondOptions ;

	return this ;
}

function TimeStone_adjustDay(){
	
}

function TimeStone_writeHTML(){
	var timeValue = this.value ;
	document.write("<input type=hidden name='"+this.name+"' id='ts_time_"+this.index+"' value=\"'"+this.value+"'\">");
	document.write("<span>");
	document.write(this.getYearOptions());
	document.write(" - ");
	document.write(this.getMonthOptions());
	document.write(" - ");
	document.write(this.getDayOptions());
	document.write(" &nbsp; &nbsp; ");
	document.write(this.getHourOptions());
	document.write(" : ");
	document.write(this.getMinuteOptions());
	document.write("</span>");
}

function TimeStone_getHTML(){
	var html = "";
	var timeValue = this.value ;
	html += "<input type=hidden name='"+this.name+"' id='ts_time_"+this.index+"' value=\"'"+this.value+"'\">";
	html += "<span>";
	html += this.getYearOptions();
	html += " - ";
	html += this.getMonthOptions();
	html += " - ";
	html += this.getDayOptions();
	html += " &nbsp; &nbsp; ";
	html += this.getHourOptions();
	html += " : ";
	html += this.getMinuteOptions();
	html += "</span>";
	return html ;
}

function TimeStone_getYearOptions(){
	var str = "<select id='ts_y_"+this.index+"' onchange=\"refreshDayOptions('"+this.index+"');setTimeValue('"+this.index+"')\">";
	if(this.allowEmpty){
		str += "<option value=''></option>";
	}
	for(var i=(this.timeY*1-10);i<=(this.timeY*1+20);i++){
		if(this.timeY == i){
			str += "<option value='"+i+"' selected>"+i+"</option>";
		}else{
			str += "<option value='"+i+"'>"+i+"</option>";
		}
	}
	str += "</select>";
	return str ;
}

function TimeStone_getMonthOptions(){
	var str = "<select id='ts_m_"+this.index+"' onchange=\"refreshDayOptions('"+this.index+"');setTimeValue('"+this.index+"')\">";
	if(this.allowEmpty){
		str += "<option value=''></option>";
	}
	for(var i=1;i<=12;i++){
		if(this.timeM == i){
			str += "<option value='"+i+"' selected>"+lpad(i,'0',2)+"</option>";
		}else{
			str += "<option value='"+i+"'>"+lpad(i,'0',2)+"</option>";
		}
	}
	str += "</select>";
	return str ;
}

function getDays(year,month){
	if(month == 2){
		if(year%400 == 0 || (year%10 != 0 && year%4 == 0)){
			return 29;
		}
		return 28;
	}
	if(month == "1" || month == "3" || month == "5" || month == "7" || month == "8" || month == "10" || month == "12"){
		return 31 ;
	}
	return 30 ;
}

function TimeStone_getDayOptions(){
	var str = "<select id='ts_d_"+this.index+"' onchange=\"setTimeValue('"+this.index+"')\">";
	var day = getDays(this.timeY,this.timeM);
	if(this.allowEmpty){
		str += "<option value=''></option>";
	}
	for(var i=1;i<=day;i++){
		if(this.timeD == i){
			str += "<option value='"+i+"' selected>"+lpad(i,'0',2)+"</option>";
		}else{
			str += "<option value='"+i+"'>"+lpad(i,'0',2)+"</option>";
		}
	}
	str += "</select>";
	return str ;
}


function TimeStone_getHourOptions(){
	var str = "<select id='ts_h_"+this.index+"' onchange=\"setTimeValue('"+this.index+"')\">";
	if(this.allowEmpty){
		str += "<option value=''></option>";
	}
	for(var i=0;i<=23;i++){
		if(this.timeH == i){
			str += "<option value='"+i+"' selected>"+lpad(i,'0',2)+"</option>";
		}else{
			str += "<option value='"+i+"'>"+lpad(i,'0',2)+"</option>";
		}
	}
	str += "</select>";
	return str ;
}

function TimeStone_getMinuteOptions(){
	var str = "<select id='ts_f_"+this.index+"' onchange=\"setTimeValue('"+this.index+"')\">";
	if(this.allowEmpty){
		str += "<option value=''></option>";
	}
	for(var i=0;i<60;i++){
		if(this.timeF == i){
			str += "<option value='"+i+"' selected>"+lpad(i,'0',2)+"</option>";
		}else{
			str += "<option value='"+i+"'>"+lpad(i,'0',2)+"</option>";
		}
	}
	str += "</select>";
	return str ;
}

function TimeStone_getSecondOptions(){
	
}

function setTimeValue(index){
	var time_y = document.getElementById("ts_y_"+index).value;
	var time_m = document.getElementById("ts_m_"+index).value;
	var time_d = document.getElementById("ts_d_"+index).value;
	var time_h = document.getElementById("ts_h_"+index).value;
	var time_f = document.getElementById("ts_f_"+index).value;
	var TStime = document.getElementById("ts_time_"+index);
	TStime.value = "'"+time_y+"-"+lpad(time_m,'0',2)+"-"+lpad(time_d,'0',2)+" "+lpad(time_h,'0',2)+":"+lpad(time_f,'0',2)+"'";
}

function refreshDayOptions(index){
	var year = document.getElementById("ts_y_"+index).value;
	var month = document.getElementById("ts_m_"+index).value;
	var days = getDays(year,month);
	var box = document.getElementById("ts_d_"+index);
	var len = box.options.length ;
	for(var i=len;i>=27;i--){
		box.options.remove(i);
	}
	for(var i=28;i<=days;i++){
		var opt = document.createElement("OPTION");
		opt.value = i ;
		opt.text = lpad(i,'0',2);
		box.options.add(opt);
	}
}