

function ErrorNode(formNode,errors){
	this.formNode = formNode ;
	this.errors = errors ;
//	this.errors = new Array();
	return this ;
}

function ElementError(id,msg){
	this.id = id ;
	this.msg = msg ;
	return this ;
}

var formErrorNodes = new Array();
var formHasNoError = true ;
var ERROR_POSITION_HEAD = 0 ;
var ERROR_POSITION_TD = 1 ;
var ERROR_POSITION_ALERT = 2 ;
var ERROR_POSITION_COOL = 3 ;

var errorPosition = ERROR_POSITION_HEAD ;

function check_form(me){
	formHasNoError = true ;
	var args = me.elements;
	formErrorNodes = new Array();

	for(var i=0;i<args.length;i++){
		var argName = args[i].getAttribute("name") ;
		if(argName == null || argName == ""){
			continue ;
		}
		args[i].value = trim(args[i].value);
		var enode = checkNodeErrors(args[i]) ;
		addFormErrorNodes(enode);
	}
	displayFormErrors();
	return formHasNoError ;
}

function addFormErrorNodes(enode){
	if(enode != null){
		formErrorNodes[formErrorNodes.length] = enode ;
		formHasNoError = false ;
	}
}

function checkNodeErrors(node){
	if(node.disabled){
		return null ;
	}
	var nodeErrors = new Array();
	checkElementNullable(nodeErrors,node);
	checkElementRType(nodeErrors,node);
	checkElementMaxLength(nodeErrors,node);
	checkElementMinLength(nodeErrors,node);
	checkElementFixLength(nodeErrors,node);
	checkElementBiggerThan(nodeErrors,node);
	checkElementBiggerAndEquals(nodeErrors,node);
	checkElementLessThan(nodeErrors,node);
	checkElementLessAndEquals(nodeErrors,node);
	if(nodeErrors.length == 0){
		clearNodeErrors(node);
		return null ;
	}
	return new ErrorNode(node,nodeErrors) ;
}
function niceErrorShow(){
	var allErrors = new Array();
	for(var i=0;i<formErrorNodes.length;i++){
		var matrix = formErrorNodes[i].errors ;
		var rname = getNodeRName(formErrorNodes[i].formNode) ;
		if(rname != null && rname != ""){
			rname = '[' + rname + '] ';
		}
		var txt = rname ;
		for(var j=0;j<matrix.length;j++){
			var error = matrix[j] ;
			txt += error.msg ;
		}
		allErrors[allErrors.length] = txt ;
	}
	showErrorsInDiv(allErrors);
}

function showErrorsInDiv(allErrors){
	if(allErrors == null || allErrors.length == 0){
		return ;
	}
	alertIframe.setAlertInfos(allErrors);
	var width = 600 ;
	var height = 260 ;
	var x = document.body.clientWidth ;
	var y = document.body.clientHeight ;
	var px = (x-width) / 2 ;
	var py = (y-height) / 2 ;
	var node = document.getElementById("alertDIVIframe");
	node.style.left = px ;
	node.style.top = py ;
	node.style.display = "block";
	alertIframe.startTimer();
}

function displayFormErrors(){
	if(errorPosition == ERROR_POSITION_COOL){
		niceErrorShow();
		return ;
		var txt = mergeErrors() ;
		if(txt == ''){
			return ;
		}
		do_alert(txt);
		try{
			formErrorNodes[0].formNode.focus();
		}catch(e){
			
		}
	}else if(errorPosition == ERROR_POSITION_TD){
		for(var i=0;i<formErrorNodes.length;i++){
			displayNodeErrors(formErrorNodes[i].formNode,formErrorNodes[i].errors);
		}
	}else if(errorPosition == ERROR_POSITION_HEAD){
		var txt = mergeErrors("<br>") ;
		var area = document.getElementById("pageErrorArea") ;
		if(txt == ''){
			if(area != null){
				area.style.display = "none";
			}
			return ;
		}
		var node = document.getElementById("pageErrors");
		if(node != null){
			node.innerHTML = txt ;
			document.getElementById("pageErrorArea").style.display = "block";
		}else{
			alert(mergeErrors("\n"));
		}
	}else if(errorPosition == ERROR_POSITION_ALERT){
		var txt = mergeErrors() ;
		if(txt == ''){
			return ;
		}
		alert(txt);
	}
}

function mergeErrors(separator){
	if(separator == null){
		separator = "\n";
	}
	var txt = '';
	for(var i=0;i<formErrorNodes.length;i++){
		var matrix = formErrorNodes[i].errors ;
		var rname = getNodeRName(formErrorNodes[i].formNode) ;
		if(rname != null && rname != ""){
			rname = '[' + rname + '] ';
		}

		txt += (i+1) + '. ' + rname ;
		for(var j=0;j<matrix.length;j++){
			var error = matrix[j] ;
			txt += error.msg ;
		}
		txt += separator ;
	}
	return txt ;
}

function getNodeRName(node){
	var rname = node.getAttribute("r_name");
	if(rname != null){
		return rname ;
	}

	try{
		var label = document.getElementById("lb_"+node.id);
		if(label != null){
			rname = getInnerText(label) ;
			if(rname != ''){
				rname = rtrim(rname,':');
				node.setAttribute("r_name",rname);
				return rname ;
			}
		}
	}catch(e){
		// alert(e);
	}

	try{
		var pnode = node.parentNode ;
		if(pnode == null){
			return '';
		}
		var preNode = pnode.previousSibling;
		if(preNode == null){
			return '';
		}else if(!isMSIE && preNode.nodeName != "TD"){
			preNode = preNode.previousSibling;
		}
		rname = getInnerText(preNode) ;
		if(rname != ''){
			var pattern = /\s/g
			rname = rname.replace(pattern,"");
			rname = rname.replace('\t',"");
			rname = ltrim(rname,'*');
			rname = rtrim(rname,':');
			node.setAttribute("r_name",rname);
			// alert("----"+rname+"-------");
			return rname ;
		}else{
			// alert(pnode.name);
		}
	}catch(e){
		// do nothing
	}
	return '';
}

function clearNodeErrors(node){
	var name = node.getAttribute("name") ;
	var span = document.getElementById("se_"+name);
	if(span == null){
		return ;
	}
	setInnerText(span,"");
}

function displayNodeErrors(node,nodeErrors){
	var name = node.getAttribute("name") ;
	var span = document.getElementById("se_"+name);
	if(span == null){
		return ;
	}
	var string = "";
	for(var i=0;i<nodeErrors.length;i++){
		var nodeError = nodeErrors[i] ;
		string += " "+nodeError.msg ;
	}
	setInnerText(span,string);
}

function checkElementNullable(errorList,node){
	if(trim(node.value) != ""){
		return ;
	}
	var att = node.getAttribute("not_null");
	if(att == null || (att.toLowerCase() != "y" && att.toLowerCase() != "yes")){
		return ;
	}
	// alert(ERROR_MSG_NOT_NULL);
	errorList[errorList.length] = new ElementError("nullable",ERROR_MSG_NOT_NULL);
}

function checkElementMaxLength(errorList,node){
	if(node.value == ""){
		return ;
	}
	var maxlen = node.getAttribute("maxlen");
	var length = node.value.length;
	if(maxlen != null && length*1 > maxlen*1){
		errorList[errorList.length] = new ElementError("maxlen",replaceAll(ERROR_MSG_MAXLEN,"#{MAXLEN}",maxlen));
	}
	return ;
}

function checkElementMinLength(errorList,node){
	if(node.value == ""){
		return ;
	}
	var minlen = node.getAttribute("minlen");
	var length = node.value.length;
	if(minlen != null && length*1 > minlen*1){
		errorList[errorList.length] = new ElementError("minlen",replaceAll(ERROR_MSG_MINLEN,"#{MINLEN}",minlen));
	}
	return ;
}

function checkElementFixLength(errorList,node){
	if(node.value == ""){
		return ;
	}
	var fixlen = node.getAttribute("fixlen");
	var length = node.value.length;
	if(fixlen != null && length*1 != fixlen*1){
		errorList[errorList.length] = new ElementError("fixlen",replaceAll(ERROR_MSG_FIXLEN,"#{FIXLEN}",fixlen));
	}
	return ;
}

function checkElementBiggerThan(errorList,node){
	if(node.value == ""){
		return ;
	}
	var bt = node.getAttribute("bt");
	if(bt != null && node.value*1 <= bt*1){
		errorList[errorList.length] = new ElementError("bigger_than",replaceAll(ERROR_MSG_BT,"#{VALUE}",bt));
	}
	return ;
}

function checkElementBiggerAndEquals(errorList,node){
	if(node.value == ""){
		return ;
	}
	var be = node.getAttribute("be");
	if(be != null && node.value*1 < be*1){
		errorList[errorList.length] = new ElementError("bigger_and_equals",replaceAll(ERROR_MSG_BE,"#{VALUE}",be));
	}
	return ;
}

function checkElementLessThan(errorList,node){
	if(node.value == ""){
		return ;
	}
	var lt = node.getAttribute("lt");
	if(lt != null && node.value*1 >= lt*1){
		errorList[errorList.length] = new ElementError("less_than",replaceAll(ERROR_MSG_LT,"#{VALUE}",lt));
	}
	return ;
}

function checkElementLessAndEquals(errorList,node){
	if(node.value == ""){
		return ;
	}
	var le = node.getAttribute("le");
	if(le != null && node.value*1 > le*1){
		errorList[errorList.length] = new ElementError("less_and_equals",replaceAll(ERROR_MSG_LE,"#{VALUE}",le));
	}
	return ;
}

function checkElementRType(errorList,node){
	if(node.value == ""){
		return ;
	}
	var r_type = node.getAttribute("r_type");
	if(r_type == null){
		return ;
	}
	if(r_type == "int"){
		if(!isInt(node.value)){
			errorList[errorList.length] = new ElementError("int_type",ERROR_MSG_INT);
		}
	}else if(r_type == "num"){
		if(!isNum(node.value)){
			errorList[errorList.length] = new ElementError("num_type",ERROR_MSG_NUM);
		}
	}else if(r_type == "account"){
		if(!isAccount(node.value)){
			errorList[errorList.length] = new ElementError("account_type",ERROR_MSG_ACCOUNT);
		}
	}else if(r_type == "email"){
		if(!isEmail(node.value)){
			errorList[errorList.length] = new ElementError("email_type",ERROR_MSG_EMAIL);
		}
	}else if(r_type == "tel"){
		if(!isTel(node.value)){
			errorList[errorList.length] = new ElementError("tel_type",ERROR_MSG_TEL);
		}
	}else if(r_type == "url"){
		if(!isUrl(node.value)){
			errorList[errorList.length] = new ElementError("url_type",ERROR_MSG_URL);
		}
	}else if(r_type == "entext"){
		if(hasChinese(node.value)){
			errorList[errorList.length] = new ElementError("entext_type",ERROR_MSG_ENTEXT);
		}
	}
}


