
var IMG_WIDTH = 23 ;
var SUB_WIDTH = 16 ;
var PADDING_WIDTH = 12 ;
var CHINESE_CHAR_WIDTH = 12 ;
var ENGLISH_CHAR_WIDTH = 6 ;
var SHADOW_WIDTH = 1 ;
var SHADOW_HEIGHT = 1 ;
var MENU_HEIGHT = 20 ;
var LINE_HEIGHT = 6 ;

var menuTableWidth = SHADOW_WIDTH ;
var menuTableHeight = LINE_HEIGHT ;

function clearDropMenus(){
	menuTableWidth = 0 ;
	menuTableHeight = 0 ;
	var node = document.getElementById("dropMenuTable");
	var len = node.rows.length;
	for(var i=(len-1);i>=0;i--){
		node.deleteRow(i);
	}
}
function addDropMenus(matrix,id){
	for(var i=0;i<matrix.length;i++){
		var menu = matrix[i] ;
		checkWidth(menu.name);
		addDropMenu(menu,id);
	}
	setTimeout("changeParentFrameSize()",100);
}
function changeParentFrameSize(){
	var url = document.URL ;
	var position = url.lastIndexOf("=");
	var index = url.substring(position*1 + 1);
	parent.changeFrameSize(index,menuTableWidth*1 + 4,menuTableHeight*1 + 3);
}
function checkWidth(txt){
	var w = calculateStringWidth(txt) + IMG_WIDTH + PADDING_WIDTH + SUB_WIDTH + SHADOW_WIDTH ;
	if(w > menuTableWidth){
		menuTableWidth = w ;
	}
}
function calculateStringWidth(str){
	var w = 0 ;
	var len = str.length ;
	for (var i=0;i<len;i++){
        if(str.charCodeAt(i)<0 || str.charCodeAt(i)>255){
			w += CHINESE_CHAR_WIDTH ;
		}else{
			w += ENGLISH_CHAR_WIDTH ;
		}
    }
	return w ;
}

function addDropMenu(menu,id){
	var t = document.getElementById("dropMenuTable");
	var rindex = t.rows.length ;
	var newRow = t.insertRow(rindex);
	newRow.className = "dropMenuOutLine";
	c0 = newRow.insertCell(0);
	c0.className = "colMenuLine";
	if(menu.name == "_SEPARATOR_"){
		c0.innerHTML = getSeparateHTML();
		menuTableHeight += LINE_HEIGHT ;
	}else{
		c0.innerHTML = getMenuHTML(menu,id,rindex);
		menuTableHeight += MENU_HEIGHT ;
	}	
}

var subMenuLock = true ;
var renderSubMenuInterval = 500 ;
var globalMenuId ;
var globalRenderId ;
var globalRindex ;
var globalOffset ;
var timeoutBar ;

function showSubMenus(menuId,event,renderId,offset){
	clearTimeoutBar();
	subMenuLock = false ;
	globalMenuId = menuId ;
	globalRenderId = renderId ;
	globalOffset = offset ;
	timeoutBar = setTimeout("renderSubMenus()",renderSubMenuInterval);
}
function renderSubMenus(){
	clearTimeoutBar();
	if(subMenuLock){
		return ;
	}
	parent.showSubMenus(globalMenuId,globalRenderId,globalOffset);
}

function clearTimeoutBar(){
	clearTimeout(timeoutBar);
	clearTimeout(timeoutBar);
	timeoutBar = null ;
	timeoutBar = null ;
}

function hiddenDropMenuDivImmediately(renderId){
	subMenuLock = true ;
	parent.hiddenDropMenuDivImmediately(renderId);
}

function hiddenSubMenus(degree){
	parent.hiddenSubMenus(degree);
	clearTimeoutBar();
}

function getMenuHTML(menu,id,rindex){
	var tableStyle = "dropMenuItemOut";
	var colStyle = "colDropMenuItemIcon";
	var iconStyle = "menuItemIcon";
	var textStyle = "colDropMenuItemText";
	var subStyle = "colDropMenuSubNoChild";
	var moveStyle = " onmouseover=\"changeMenuItemCss(this);showSubMenus('"+menu.id+"',event,'"+id+"','"+menuTableHeight+"')\"";
	var clickEvent = "";
	if(menu.method == null || menu.method == ""){
		//" onclick=\"hiddenDropMenuDivImmediately('"+id+"');parent."+menu.method+"\"";
	}else{
		clickEvent = " onclick=\"hiddenDropMenuDivImmediately('"+id+"');parent."+menu.method+"\"";
	}

	var buffer = new StringBuffer();
	if(menu.hasChild()){
		subStyle = "colDropMenuSubHasChild";
	}else{
		if(menu.enable){
			moveStyle = " onmouseover=\"changeMenuItemCss(this);hiddenSubMenus('"+menu.rank+"','"+id+"')\"";
		}else{
			moveStyle = " onmouseover=\"hiddenSubMenus('"+menu.rank+"')\"";
		}
	}
	if(!menu.enable){
		tableStyle = "dropMenuItemOutDisabled";
		colStyle = "colDropMenuItemIconDisabled";
		iconStyle = "menuItemIconDisabled";
		textStyle = "colDropMenuItemTextDisabled";
		if(menu.hasChild()){
			subStyle = "colDropMenuSubDisabled";
		}
		clickEvent = "";
		moveStyle = " onmouseover=\"hiddenSubMenus('"+menu.rank+"')\"";
	}

	buffer.append("<table class='").append(tableStyle).append("'").append(moveStyle).append(clickEvent).append(" cellpadding=0 cellspacing=0>");
	buffer.append("<tr>");
	buffer.append("<td class='").append(colStyle).append("'><div style='width:").append(IMG_WIDTH).append("px;");
	if(menu.icon != null && menu.icon != ""){
		buffer.append("background-image:url(").append(menu.icon).append(");background-repeat:no-repeat;background-position:50% 50%;border:red 0px solid;");
	}
	buffer.append("'></div></td>");

	buffer.append("<td class='").append(textStyle).append("'").append("><div style='width:100%;'>");
	buffer.append(menu.name) ;
	buffer.append("</div></td>");

	buffer.append("<td class='").append(subStyle).append("'><div style='width:").append(SUB_WIDTH).append("px;'></div></td>");
	buffer.append("</tr>");
	buffer.append("</table>");
	return buffer.toString() ;
}
function getSeparateHTML(){
	var buffer = new StringBuffer();
	buffer.append("<img src='../../include/images/bgSeparator.gif' class='separateLine'></img>");
	return buffer.toString() ;
}
var preMenuItem ;
function changeMenuItemCss(me){
	if(preMenuItem != null){
		preMenuItem.className = "dropMenuItemOut";
	}
	me.className = 'dropMenuItemOver';
	preMenuItem = me ;
}
